import java.io.*;
import java.net.*;
//import java.sql.*;
import java.util.*;

import org.apache.log4j.Logger;
import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.hibernate.Transaction;

class Communication extends Thread 
{   
	private ServerSocket ss;
	private InputStream in;
	private Socket client;
	private String clientIP;
	private int localPort;
	private String riadok;
	private InputStreamReader isr;
	private BufferedReader br;
	private Socket sendingSocket;
	private OutputStreamWriter out; 
	private Transaction tx;
	private static Session session = HibernateSessionFactory.getInstance().getCurrentSession();
	private boolean logged=false;
	private int port;
	
	private static Logger log =Logger.getLogger(Communication.class);
    
    public Communication ( Socket client ) throws SocketException 
    {	this.client = client;
		setPriority( NORM_PRIORITY - 1 );
		tx = null;
		System.out.println("NOVE VLAKNO");
    }
    
    public Communication()
    {	Pouzivatel p = new Pouzivatel("meno","priez", "1","login","pass");
		tx = session.beginTransaction();
		session.save(p);
		tx.commit();
    
    }
    
    public void run() 
    {	System.out.println("zaciatok vlakna");
    	
    	try 
		{	
			ss=null;
    		while(ss==null)
    		{	ss=new ServerSocket((int) (Math.random()*60000) + 4000);
    			System.out.print("x ");
    		}
    		clientIP=client.getInetAddress().getHostAddress();
			System.out.println(clientIP);
			System.out.print("0 ");
    		localPort=ss.getLocalPort();
    		System.out.println(localPort);
    		readMessage(client);
			while(true)
			{	System.out.println("cakam dalsi paket");
				readMessage(ss.accept());
				
			}
			
		} 
		catch (IOException e) 
		{	System.out.println( "I/O error " + e ); 
		}
		return;
    }
    
    private void readMessage(Socket client)
    {	try
    	{	in =client.getInputStream() ;
    		isr = new InputStreamReader(in);
			br = new BufferedReader(isr);
			
    		riadok=br.readLine();
    		System.out.println("1"+riadok);
    		while (riadok!=null) 
			{	if(riadok.indexOf("<login>")>-1)
					login();
				if(logged && riadok.indexOf("<studList>")>-1)
				{	System.out.println("StudentList "+out+"\n");
					sendingSocket=new Socket(clientIP,port);
					out = new OutputStreamWriter(sendingSocket.getOutputStream());
					System.out.println("StudentList\n");
					out.write(studentList());
	    			out.flush();
	    			out.close();
				}
				if(logged && riadok.indexOf("<addUser>")>-1)
					addUser();
				if(logged && riadok.indexOf("<subjList>")>-1)
				{	sendingSocket=new Socket(clientIP,port);
					out = new OutputStreamWriter(sendingSocket.getOutputStream());
					System.out.println("Predmety\n");
					out.write(predmety());
					out.flush();
    				out.close();
				
				}
				
				//				doplnit dalsie metody !!!!
				riadok=br.readLine();
				System.out.println("1"+riadok);
			}
    	}
    	catch(IOException e)
    	{	
    	}
    }
    
    private void login()
    {	String login="", pass="";
    	
    	try 
    	{	//System.out.println("login");
    		riadok=br.readLine();
    		while(riadok!=null && riadok.indexOf("</login>")<0)
	    	{	if(riadok.indexOf("<name>")>-1)
	    			login=riadok.substring(riadok.indexOf("<name>")+new String("<name>").length(), riadok.indexOf("</name>"));
	    		if(riadok.indexOf("<pass>")>-1)
	    			pass=riadok.substring(riadok.indexOf("<pass>")+new String("<pass>").length(), riadok.indexOf("</pass>"));
	    		if(riadok.indexOf("<port>")>-1)
	    		{	port = new Integer(riadok.substring(riadok.indexOf("<port>")+new String("<port>").length(), riadok.indexOf("</port>"))).intValue();
	    			System.out.println("Tiborov port"+port);
	    			sendingSocket=new Socket(clientIP,port);
	    		}
    			riadok=br.readLine();
	    	}
    		System.out.println(login+" "+pass);
    		out = new OutputStreamWriter(sendingSocket.getOutputStream());
    		out.write(checkLogin(login,pass));
    		out.flush();
    		out.close();
    	} 
    	catch (IOException e) 
	    {	e.printStackTrace();
	    }
    	
    }
    
    
    
    private String checkLogin(String login, String pass)
    {	StringBuffer sb=new StringBuffer("<?xml version 1.0 encoding='UTF-8'?>\n");
    	
    	try {
	    	tx = session.beginTransaction();
			List Student = session.createQuery("from Pouzivatel p where p.login='"+login+"' and p.password='"+pass+"'").list();
	    	Iterator iter = Student.iterator();
	    	sb.append("<login_answ>\n");
	    	if(iter.hasNext())
	    	{	logged=true;
	    		sb.append("<serverPort>"+localPort+"</serverPort>\n");
	    		Pouzivatel pouz = (Pouzivatel) iter.next();
	    		System.out.println(pouz.getMeno()+" "+pouz.getPriezvisko());
	    		sb.append("<access>success</access>\n");
	    		sb.append("<name>"+pouz.getMeno()+"</name>\n");
	    		sb.append("<surname>"+pouz.getPriezvisko()+"</surname>\n");
	    		sb.append("<type>"+pouz.getTypPouzivatela()+"</type>\n");
	    	}
	    	else
	    		sb.append("<access>denied</access>\n");
	    	sb.append("</login_answ>\n");
	    	System.out.println(sb.toString());
	    	return sb.toString();
    	} 
    	catch (HibernateException e) 
    	{	e.printStackTrace();
			if (tx != null && tx.isActive())
				tx.rollback();
			return "";
		}
    }
    
    private String studentList()
    {	Pouzivatel p;
    	StringBuffer sb=new StringBuffer();
    
    	tx = session.beginTransaction();
		List Student = session.createQuery("from Pouzivatel p where p.typPouzivatela=1").list();
		Iterator iter = Student.iterator();
		System.out.println(Student.size());
		sb.append("<studList_answ>\n");
		sb.append("<count>"+Student.size()+"</count>\n");
    	while(iter.hasNext())
    	{	p= (Pouzivatel) iter.next();
    		sb.append("<student>\n");
    		sb.append("<name>"+p.getMeno()+"</name>\n");
    		sb.append("<surname>"+p.getPriezvisko()+"</surname>\n");
    		sb.append("</student>\n");
    	}
    	sb.append("</studList_answ>\n");
    	System.out.println("POSIELAM TOTO:\n\n"+sb.toString()+"\n\n");
    	return sb.toString();
    }
    
    private void addUser()
    {	String meno="", priez="", typ="", login="", pass="";
    	
    	System.out.println("new User");
	    try 
		{	//System.out.println("login");
			riadok=br.readLine();
			while(riadok!=null && riadok.indexOf("</addUser>")<0)
	    	{	if(riadok.indexOf("<name>")>-1)
	    			meno=riadok.substring(riadok.indexOf("<name>")+new String("<name>").length(), riadok.indexOf("</name>"));
	    		if(riadok.indexOf("<surname>")>-1)
	    			priez=riadok.substring(riadok.indexOf("<surname>")+new String("<surname>").length(), riadok.indexOf("</surname>"));
	    		if(riadok.indexOf("<type>")>-1)
	    			typ=riadok.substring(riadok.indexOf("<type>")+new String("<type>").length(), riadok.indexOf("</type>"));
	    		if(riadok.indexOf("<prihlMeno>")>-1)
	    			login=riadok.substring(riadok.indexOf("<prihlMeno>")+new String("<prihlMeno>").length(), riadok.indexOf("</prihlMeno>"));
	    		if(riadok.indexOf("<password>")>-1)
	    			pass=riadok.substring(riadok.indexOf("<password>")+new String("<password>").length(), riadok.indexOf("</password>"));
	    		
				riadok=br.readLine();
	    	}
			Pouzivatel p = new Pouzivatel(meno,priez, typ,login,pass);
			tx = session.beginTransaction();
			session.save(p);
			System.out.println(session.isConnected());
		} 
		catch (IOException e) 
	    {	e.printStackTrace();
	    }
		catch (HibernateException e) {
			e.printStackTrace();
			if (tx != null && tx.isActive())
				tx.rollback();
		}
    }
    
    private String predmety()
    {	String name="", meno, priezvisko;
    	StringTokenizer st;
    	StringBuffer sb=new StringBuffer();
    
    	try{
    		riadok=br.readLine();
    
    		while(riadok!=null && riadok.indexOf("</subjList>")<0)
    		{	if(riadok.indexOf("<name>")>-1)
    				name=riadok.substring(riadok.indexOf("<name>")+new String("<name>").length(), riadok.indexOf("</name>"));
    			riadok=br.readLine();
    		}
    		st=new StringTokenizer(name,",");
    		sb.append("<subjList_answ>\n");
    		if(st.countTokens()>0)
    		{	meno=st.nextToken();
    			priezvisko=st.nextToken();
    			tx = session.beginTransaction();
				List Predmety = session.createQuery("from Pouzivatel p where p.meno='"+meno+"' and p.priezvisko='"+priezvisko+"'").list();
				Iterator iter = Predmety.iterator(); 
				if(iter.hasNext())
				{	Pouzivatel element = (Pouzivatel) iter.next();
					Iterator<Predmet> it = element.writePredmety();
					sb.append("<count>"+element.countPredmety()+"</count>\n");
					while(it.hasNext())
					{	sb.append("<subject>\n");
						sb.append("<name>"+it.next().getNazov()+"</name>\n");
						sb.append("</subject>\n");
					}
				}
				else
				{	sb.append("<count>0</count>\n");
				}
				sb.append("</subjList_answ>\n");
				System.out.println(sb.toString());
				return sb.toString();
    		}
    	}
    	catch(IOException e)
    	{
    	}
    	return sb.toString();
    }
    
    private void listStudent() {
		try {
			tx = session.beginTransaction();
			List Student = session.createQuery("from Pouzivatel")
							.list();
			for (Iterator iter = Student.iterator(); iter.hasNext();) {
				Pouzivatel element = (Pouzivatel) iter.next();
//				log.debug(element);
				System.out.println("\n"+element.getMeno()+" "+element.getPriezvisko()+" "+element.getLogin()+" "+element.getPassword()+" "+element.getTypPouzivatela());
				element.writePredmety();
			}
			tx.commit();
		} catch (HibernateException e) {
			e.printStackTrace();
			if (tx != null && tx.isActive())
				tx.rollback();
		}
	}
    
//    private static void createPredmet(Predmet p) {
//		Transaction tx = null;
//		Session session = HibernateSessionFactory.getInstance().getCurrentSession();
//		try {
//			tx = session.beginTransaction();
//			session.save(p);
//			tx.commit();
//		} catch (HibernateException e) {
//			e.printStackTrace();
//			if (tx != null && tx.isActive())
//				tx.rollback();
//		}
//	}
}